﻿Public Class cStoreDirectProxy
    Inherits cStoreRegistry

    Private Const PROXY_ROOT_PATH = "DirectProxies\\"

    Public Sub New()

    End Sub

    '///////////////////////////////////////////////////////////////////////////////////
    '///////////////////////////////////////////////////////////////////////////////////

    Public Function AddDirectProxySIP(ByVal sProxyName As String, ByVal sAuthLogin As String, ByVal sAuthUser As String, ByVal sAuthPwd As String, ByVal sDomainRealm As String, ByVal sProxyIP As String, ByVal nProxyPort As Integer, ByVal sCodecList As String) As Boolean

        If (sProxyName.Length = 0) Then
            Return False
        End If

        Dim sPath As String = PROXY_ROOT_PATH + sProxyName

        MyBase.SetTEXT(sPath, "AuthLogin", sAuthLogin)
        MyBase.SetTEXT(sPath, "AuthUser", sAuthUser)
        MyBase.SetTEXT(sPath, "AuthPwd", sAuthPwd)

        MyBase.SetTEXT(sPath, "DomainRealm", sDomainRealm)
        MyBase.SetTEXT(sPath, "ProxyIP", sProxyIP)
        MyBase.SetTEXT(sPath, "CodecList", sCodecList)

        MyBase.SetINT(sPath, "ProxyPort", nProxyPort)

        Return True

    End Function

    Public Sub RemoveDirectProxySIP(ByVal sProxyName As String)

        If (sProxyName.Length = 0) Then
            Return
        End If


        Dim sPath As String = PROXY_ROOT_PATH + sProxyName
        MyBase.DeleteSubKey(sPath)

    End Sub

    '//////////////////////////////////////////////////////////////////////////////////////////
    '//////////////////////////////////////////////////////////////////////////////////////////

    Public Function GetDirectProxySIP(ByVal sProxyName As String, ByRef sAuthLogin As String, ByRef sAuthUser As String, ByRef sAuthPwd As String, ByRef sDomainRealm As String, ByRef sProxyIP As String, ByRef nProxyPort As Integer, ByRef sCodecList As String) As Boolean

        If (sProxyName.Length = 0) Then
            Return False
        End If

        Dim sPath As String = PROXY_ROOT_PATH + sProxyName

        MyBase.GetTEXT(sPath, "AuthLogin", sAuthLogin)
        MyBase.GetTEXT(sPath, "AuthUser", sAuthUser)
        MyBase.GetTEXT(sPath, "AuthPwd", sAuthPwd)

        MyBase.GetTEXT(sPath, "DomainRealm", sDomainRealm)
        MyBase.GetTEXT(sPath, "ProxyIP", sProxyIP)
        MyBase.GetTEXT(sPath, "CodecList", sCodecList)

        MyBase.GetINT(sPath, "ProxyPort", nProxyPort)

        Return True

    End Function

    Public Function GetDirectProxySIPAll(ByRef objProxyList As List(Of String)) As Boolean

        objProxyList.Clear()

        Dim sPath As String = PROXY_ROOT_PATH
        Return MyBase.EnumSubKeys(sPath, objProxyList)

    End Function

    '//////////////////////////////////////////////////////////////////////////////////////////
    '//////////////////////////////////////////////////////////////////////////////////////////

    Public Function AddDirectProxyRoute(ByVal sProxyName As String, ByVal nToPeerType As Integer, ByVal sToPeerName As String, ByVal bRejected As Boolean, ByVal sRoomName As String, ByVal sQueueName As String, ByVal sRingGroupName As String) As Boolean

        If (sProxyName.Length = 0) Then
            Return False
        End If

        Dim sPath As String = PROXY_ROOT_PATH + sProxyName

        MyBase.SetINT(sPath, "ToPeerType", nToPeerType)
        MyBase.SetBOOL(sPath, "Rejected", bRejected)

        MyBase.SetTEXT(sPath, "ToPeerName", sToPeerName)
        MyBase.SetTEXT(sPath, "RoomName", sRoomName)

        MyBase.SetTEXT(sPath, "QueueName", sQueueName)
        MyBase.SetTEXT(sPath, "RingGroupName", sRingGroupName)

        Return True

    End Function

    Public Function GetDirectProxyRoute(ByVal sProxyName As String, ByRef nToPeerType As Integer, ByRef sToPeerName As String, ByRef bRejected As Boolean, ByRef sRoomName As String, ByRef sQueueName As String, ByRef sRingGroupName As String) As Boolean

        If (sProxyName.Length = 0) Then
            Return False
        End If

        Dim sPath As String = PROXY_ROOT_PATH + sProxyName

        MyBase.GetINT(sPath, "ToPeerType", nToPeerType)
        MyBase.GetBOOL(sPath, "Rejected", bRejected)

        MyBase.GetTEXT(sPath, "ToPeerName", sToPeerName)
        MyBase.GetTEXT(sPath, "RoomName", sRoomName)

        MyBase.GetTEXT(sPath, "QueueName", sQueueName)
        MyBase.GetTEXT(sPath, "RingGroupName", sRingGroupName)
        Return True

    End Function

    Public Function RemoveDirectProxyRoute(ByVal sProxyName As String) As Boolean

        If (sProxyName.Length = 0) Then
            Return False
        End If

        Dim sPath As String = PROXY_ROOT_PATH + sProxyName

        MyBase.DeleteValue(sPath, "ToPeerType")
        MyBase.DeleteValue(sPath, "Rejected")

        MyBase.DeleteValue(sPath, "ToPeerName")
        MyBase.DeleteValue(sPath, "RoomName")

        MyBase.DeleteValue(sPath, "QueueName")
        MyBase.DeleteValue(sPath, "RingGroupName")

        Return True

    End Function

    Public Function IsDataStored() As Boolean
        Return MyBase.IsKeyExist(PROXY_ROOT_PATH)
    End Function

End Class
