﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace ServerSIP
{
    class cCallPickUpDetails
    {
        public string m_sPickUpGroupName = "";

        cCallPickUpMemberList m_objMemberList = null;

        public cCallPickUpDetails(string sPickUpGroupName)
        {
            m_sPickUpGroupName = sPickUpGroupName;
            m_objMemberList = new cCallPickUpMemberList();
        }

        ~cCallPickUpDetails()
        { 
        }

        public bool AddCallPickUpGroupMember(string sMemberName)
        {
            return m_objMemberList.AddMember(sMemberName);
        }

        public void RemoveCallPickUpGroupMember(string sMemberName)
        {
            m_objMemberList.RemoveMember(sMemberName);
        }

        public bool GetPickUpMemberList(ref List<string> objListMemberName)
        {
            return m_objMemberList.GetMemberList(ref objListMemberName);
        }

        public bool IsGroupMember(string sMemberName)
        {
            return m_objMemberList.IsGroupMember(sMemberName);
        }
    }

    
    ///////////////////////////////////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////////////////////
    
    class cCallPickUpList
    {
        Dictionary<string, cCallPickUpDetails> m_objCallPickUpListMap = new Dictionary<string,cCallPickUpDetails>();

        public bool AddCallPickUpGroup(string sCallPickUpGroupName)
        {
            cCallPickUpDetails objDetails = null;

            m_objCallPickUpListMap.TryGetValue(sCallPickUpGroupName, out objDetails);

            if(objDetails == null)
            {
                objDetails = new cCallPickUpDetails(sCallPickUpGroupName);
                m_objCallPickUpListMap.Add(sCallPickUpGroupName, objDetails);
            }

            return true;
        }

        public void RemoveCallPickUpGroup(string sCallPickUpGroupName)
        {
            m_objCallPickUpListMap.Remove(sCallPickUpGroupName);
        }

        public void DeletePickGroupAll()
        {
            m_objCallPickUpListMap.Clear();
        }

        public bool AddCallPickUpGroupMember(string sCallPickUpGroupName, string sMemberName)
        {
            cCallPickUpDetails objDetails = null;

            m_objCallPickUpListMap.TryGetValue(sCallPickUpGroupName, out objDetails);
            if(objDetails == null) return false;

            return objDetails.AddCallPickUpGroupMember(sMemberName);
        }

        public void RemoveCallPickUpMember(string sCallPickUpGroupName, string sMemberName)
        {
            cCallPickUpDetails objDetails = null;

            m_objCallPickUpListMap.TryGetValue(sCallPickUpGroupName, out objDetails);
            if(objDetails == null) return;

            objDetails.RemoveCallPickUpGroupMember(sMemberName);
        }

        public cCallPickUpDetails FindCallPickUp(string sCallPickUpGroupName)
        {
            cCallPickUpDetails objDetails = null;

            m_objCallPickUpListMap.TryGetValue(sCallPickUpGroupName, out objDetails);
            if(objDetails == null) return null;

            return objDetails;
        }

        public bool GetAllPickUpGroupName(ref List<string> objListPickUpName)
        {
            cCallPickUpDetails objDetails = null;

            foreach (KeyValuePair<string, cCallPickUpDetails> sPickUpGroupName in m_objCallPickUpListMap)
            {
                objDetails = sPickUpGroupName.Value;
                objListPickUpName.Add(objDetails.m_sPickUpGroupName);
            }

            return true;
        }

        public bool GetPickUpMemberName(string sCallPickUpGroupName, ref List<string> objListMemberName)
        {
            cCallPickUpDetails objDetails = null;

            m_objCallPickUpListMap.TryGetValue(sCallPickUpGroupName, out objDetails);
            if(objDetails == null) return false;

            return objDetails.GetPickUpMemberList(ref objListMemberName);
        }

        public bool IsGroupMember(string sCallPickUpGroupName, string sMemberName)
        {
            cCallPickUpDetails objDetails = null;

            m_objCallPickUpListMap.TryGetValue(sCallPickUpGroupName, out objDetails);
            if(objDetails == null) return false;

            return objDetails.IsGroupMember(sMemberName);
        }
    }
}
