﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace ServerSIP
{
    class cQueueDetails
    {
        public string m_sQueueName;
        
        public string m_sQueueMusicFile;
        public string m_sQueueDialToneFile;

        public int m_nQueueMusicId;
        public int m_nQueueDialToneId;

        public string m_sUserName;

        public int m_nProcessMode;
        public int m_nProcessType;
        public int m_nPriorityWeight;

        cQueueAgentList m_objQueueAgentList;

        public cQueueDetails(string sQueueName)
        {
            m_sQueueName = sQueueName;
            m_objQueueAgentList = new cQueueAgentList();
        }

       ~cQueueDetails()
        {
            m_objQueueAgentList.RemoveAll();
        }
        
	    public bool AddQueueAgent(string sUserName)
        {
            return m_objQueueAgentList.AddAgent(sUserName);
        }

	    public bool IsAgentExist(string sUserName)
        {
            return m_objQueueAgentList.IsAgentExist(sUserName);
        }

        public void GetQueueAgentList(ref List<string> objListUserName)
        {
            for (int nIndex = 0; nIndex < m_objQueueAgentList.GetQueueAgentCount(); nIndex++)
            {
                objListUserName.Add(m_objQueueAgentList.GetQueueAgentAt(nIndex));
            }
        }

        public void RemoveQueueAgent(string sUserName)
        {
            m_objQueueAgentList.RemoveAgent(sUserName);
        }
	
	    public string GetQueueAgentAt(int nIndex)
        {
            return m_objQueueAgentList.GetQueueAgentAt(nIndex);
        }

	    public int GetQueueAgentCount()
        {
           
           return m_objQueueAgentList.GetQueueAgentCount();
        }
    }
        
    ////////////////////////////////////////////////////////////////////////////////////////////////////////
    ////////////////////////////////////////////////////////////////////////////////////////////////////////
    
    class cQueueList
    {
        Dictionary<string, cQueueDetails> m_objDetailobjList = new Dictionary<string, cQueueDetails>();

        public bool AddQueue(string sQueueName, string sQueueMusicFile, int nQueueMusicId, string sQueueDialToneFile, int nQueueDialToneId)
        {
            cQueueDetails objDetails = null;

            m_objDetailobjList.TryGetValue(sQueueName, out objDetails);

            if(objDetails == null)
            {
                objDetails = new cQueueDetails(sQueueName);
                m_objDetailobjList.Add(sQueueName, objDetails);
            }
         
            objDetails.m_sQueueName = sQueueName;

            objDetails.m_sQueueMusicFile = sQueueMusicFile;
            objDetails.m_nQueueMusicId = nQueueMusicId;

            objDetails.m_sQueueDialToneFile = sQueueDialToneFile;
            objDetails.m_nQueueDialToneId = nQueueDialToneId;
            
            return true;
        }

        public void DeleteQueueAll()
        {
            m_objDetailobjList.Clear();
        }

	    public void RemoveQueue(string sQueueName)
        {
            cQueueDetails objDetails = null;
            m_objDetailobjList.TryGetValue(sQueueName, out objDetails);

            if(objDetails == null)
                return;

            m_objDetailobjList.Remove(sQueueName);
        }

	    public bool AddQueueAgent(string sQueueName, string sUserName)
        {
            cQueueDetails objDetails = null;
            m_objDetailobjList.TryGetValue(sQueueName, out objDetails);

            if(objDetails == null)
                return false;

            return objDetails.AddQueueAgent(sUserName);
        }

	    public void RemoveQueueAgent(string sQueueName, string sUserName)
        {
            cQueueDetails objDetails = null;

            m_objDetailobjList.TryGetValue(sQueueName, out objDetails);

            if(objDetails == null)
                return;

           objDetails.RemoveQueueAgent(sUserName);
        }
	
	    public bool IsAgentExisted(string sQueueName, string sUserName)
        {
            cQueueDetails objDetails = null;

            m_objDetailobjList.TryGetValue(sQueueName, out objDetails);

            if(objDetails == null)
                return false;

            return objDetails.IsAgentExist(sUserName);
        }

	    public bool GetQueueNameList(ref List<string> objListQueueName)
        {
            cQueueDetails objDetails = null;

            foreach (KeyValuePair<string, cQueueDetails> sQueueName in m_objDetailobjList)
            {
                objDetails = sQueueName.Value;
                objListQueueName.Add(objDetails.m_sQueueName);
            }
            return true;
        }

        public bool GetQueueDetails(string sQueueName, ref int nProcessMode, ref  int nProcessType, ref List<string> objListQueueAgent, ref string sQueueMusicFile, ref string sQueueDialToneFile)
        {
            cQueueDetails objDetails = null;

            m_objDetailobjList.TryGetValue(sQueueName, out objDetails);

            if(objDetails == null)
                return false;

            nProcessMode = objDetails.m_nProcessMode;
            nProcessType = objDetails.m_nProcessType;

            sQueueMusicFile = objDetails.m_sQueueMusicFile;
            sQueueDialToneFile = objDetails.m_sQueueDialToneFile;

            objDetails.GetQueueAgentList(ref objListQueueAgent);
            
            return true;
        }

        public void SetQueueProcessMode(string sQueueName, int nProcessMode, int nProcessType)
        {
            cQueueDetails objDetails = null;

            m_objDetailobjList.TryGetValue(sQueueName, out objDetails);

            if(objDetails == null)
                return;

            objDetails.m_nProcessMode = nProcessMode;
            objDetails.m_nProcessType = nProcessType;
        }

        public void SetQueueAgentPriority(string sQueueName, string sUserName, int nPriorityWeight)
        {
            cQueueDetails objDetails = null;

            m_objDetailobjList.TryGetValue(sQueueName, out objDetails);

            if(objDetails == null)
                return;

            objDetails.m_sQueueName = sQueueName;
            objDetails.m_sUserName = sUserName;
            objDetails.m_nPriorityWeight = nPriorityWeight;

        }

	    public String GetQueueAgentAt(string sQueueName, int nIndex)
        {
            cQueueDetails objDetails = null;

            m_objDetailobjList.TryGetValue(sQueueName, out objDetails);

            if(objDetails == null)
                return "";
            return objDetails.GetQueueAgentAt(nIndex);
            
        }

	    public int GetQueueAgentCount(string sQueueName)
        {
            cQueueDetails objDetails = null;

            m_objDetailobjList.TryGetValue(sQueueName, out objDetails);

            if(objDetails == null)
                return 0;

            return objDetails.GetQueueAgentCount();
        }

        public int GetQueueMusicId(string sQueueName)
        {
            cQueueDetails objDetails = null;

            m_objDetailobjList.TryGetValue(sQueueName, out objDetails);

            if(objDetails == null)
                return -1;

            return objDetails.m_nQueueMusicId;
        }

        public int GetQueueDialToneId(string sQueueName)
        {
            cQueueDetails objDetails = null;

            m_objDetailobjList.TryGetValue(sQueueName, out objDetails);

            if(objDetails == null)
                return -1;

            return objDetails.m_nQueueDialToneId;
        }
    }
}
