﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace ServerSIP
{
    class cVaxQueue
    {
        public cVaxQueue()
        {

        }

        ~cVaxQueue()
        {
        }

        ///////////////////////////////////////////////////////////////////////////////////////////
        ///////////////////////////////////////////////////////////////////////////////////////////

        public void OnIncomingCall(int nSessionId, string sCallerName, string sCallerId, string sQueueName, ref bool bProcessed)
        {
            bProcessed = false; 

            if(sQueueName.Length == 0)
              return;

            if(!cVaxServerExCOM.m_objVaxServerExCOM.AddCallSessionToQueue(sQueueName, sCallerName, sCallerId, nSessionId, 20))
            {
                return;
            }

            bProcessed = true;
        }

        public void OnAddCallSessionToQueueSuccess(string sQueueName, int nSessionId)
        {
            
        }

        public void OnAddCallSessionToQueueFailed(string sQueueName, int nSessionId)
        {

        }
        
        public void OnQueuePlayWaveStart(int nEventType, string sQueueName, int nSessionId)
        {
            if(nEventType == cVaxServerCOM.VAX_QUEUE_PLAY_WAVE_EVENT_TYPE_MUSIC)
            {
                int nQueueMusicId = cVaxServerExCOM.m_objVaxServerExCOM.GetQueueMusicId(sQueueName);

                if(nQueueMusicId == -1)
                    return;

                cVaxServerExCOM.m_objVaxServerExCOM.PlayWaveStartToCallSession(nSessionId, cVaxServerCOM.VAX_CALL_CHANNEL_ZERO, nQueueMusicId, true, 0);
                return;
            }

            int nQueueDialToneId = cVaxServerExCOM.m_objVaxServerExCOM.GetQueueDialToneId(sQueueName);

            if(nQueueDialToneId == -1)
              return;

            cVaxServerExCOM.m_objVaxServerExCOM.PlayWaveStartToCallSession(nSessionId, cVaxServerCOM.VAX_CALL_CHANNEL_ZERO, nQueueDialToneId, true, 0);

        }

        public void OnQueuePlayWaveStop(int nEventType, string sQueueName, int nSessionId)
        {
            if(nEventType == cVaxServerCOM.VAX_QUEUE_PLAY_WAVE_EVENT_TYPE_MUSIC)
            {
                int nQueueMusicId = cVaxServerExCOM.m_objVaxServerExCOM.GetQueueMusicId(sQueueName);

                if(nQueueMusicId == -1)
                    return;
                
                cVaxServerExCOM.m_objVaxServerExCOM.PlayWaveStopToCallSession(nSessionId, cVaxServerCOM.VAX_CALL_CHANNEL_ZERO, nQueueMusicId);
                return;
            }

            int nQueueDialToneId = cVaxServerExCOM.m_objVaxServerExCOM.GetQueueDialToneId(sQueueName);

            if(nQueueDialToneId == -1)
              return;

            cVaxServerExCOM.m_objVaxServerExCOM.PlayWaveStopToCallSession(nSessionId, cVaxServerCOM.VAX_CALL_CHANNEL_ZERO, nQueueDialToneId);

        }  
    }
}
